-- The mud interface.

-- send to player
function send(char, ...)
	send_to_char(char.id, table.concat {...} .. "\n\r")
	return
end -- send

-- formatted send to player - with newline
function fsend (s, ...)
	send_to_char(string.format (s, ...) .. "\n\r")
	return
end -- fsend

-- send to player, no new line
function send_nocr(char, ...)
	send_to_char(char.id, table.concat {...})
	return
end -- send_nocr

-- echo at room
function echo(room, ...)
	recho(room, table.concat {...} .. "\n\r")
	return
end -- echo

-- echo at room vnum
function echoat(vnum, ...)
	room = get_room_index(vnum)
	echo(room, ...)
	return
end

-- echo around a character, but not to that character
function echoaround(char, ...)
	rechoaround(char, table.concat {...} .. "\n\r")
	return
end -- echoaround

function sleep(ch, seconds)
	local start = mud:time()

	while mud:time() - start < seconds do
		coroutine.yield()
	end
	return
end -- sleep

