// Lua implementation.
// Copyright (c) 2012 by Kasji.

#include <stdio.h>
#include "mud.h"
#include "lua.h"

extern L_UPDATER * g_luaUpdater;

tPointerOwner<L_COROUTINE> coroutine_map;

lua_updater::lua_updater()
{
}

lua_updater::~lua_updater()
{
}

void lua_updater::update()
{
	const char * msg;
	L_COR_IT it;
	L_COROUTINE * cor;
	int status;

	if (this->m_coroutine_list.empty())
		return;

	it = this->m_coroutine_list.begin();
	while (it != this->m_coroutine_list.end())
	{
		cor = coroutine_map[(*it)];
		status = cor->status();
		if (status == LUA_YIELD)
		{
			cor->resume();
			++it;
			continue;
		}
		else if (status == 0)
		{
			it = this->killthread(it);
			continue;
		}
		else
		{
			if (cor->L() && lua_isstring(cor->L(), -1))
			{
				msg = lua_tostring(cor->L(), -1);
				log_lua("lua_updater::update(): %d: %s\n\r    Owner Type: %s  Owner ID: %llu", status, msg, cor->owner_type(), cor->owner_id());
			}
			it = this->killthread(it);
			continue;
		}
	}

	return;
}

L_COROUTINE * lua_updater::newthread(const char * type, uint64 id)
{
	L_COROUTINE * cor = new L_COROUTINE(type, id);
	this->m_coroutine_list.push_back(cor->GetId().Value());

	return cor;
}

void lua_updater::killthread(uint64 id)
{
	delete coroutine_map[id];
	this->m_coroutine_list.remove(id);
	return;
}

L_COR_IT lua_updater::killthread(L_COR_IT it)
{
	delete coroutine_map[(*it)];
	return this->m_coroutine_list.erase(it);
}

void lua_update()
{
	g_luaUpdater->update();

	return;
}

